#[doc = "Register `SATURATE_INTR_MASKED` reader"]
pub struct R(crate::R<SATURATE_INTR_MASKED_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<SATURATE_INTR_MASKED_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<SATURATE_INTR_MASKED_SPEC>> for R {
    fn from(reader: crate::R<SATURATE_INTR_MASKED_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `SATURATE_INTR_MASKED` writer"]
pub struct W(crate::W<SATURATE_INTR_MASKED_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<SATURATE_INTR_MASKED_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<SATURATE_INTR_MASKED_SPEC>> for W {
    fn from(writer: crate::W<SATURATE_INTR_MASKED_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `SATURATE_MASKED` reader - Logical and of corresponding request and mask bits."]
pub struct SATURATE_MASKED_R(crate::FieldReader<u16, u16>);
impl SATURATE_MASKED_R {
    pub(crate) fn new(bits: u16) -> Self {
        SATURATE_MASKED_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for SATURATE_MASKED_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:15 - Logical and of corresponding request and mask bits."]
    #[inline(always)]
    pub fn saturate_masked(&self) -> SATURATE_MASKED_R {
        SATURATE_MASKED_R::new((self.bits & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Saturate interrupt masked request register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [saturate_intr_masked](index.html) module"]
pub struct SATURATE_INTR_MASKED_SPEC;
impl crate::RegisterSpec for SATURATE_INTR_MASKED_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [saturate_intr_masked::R](R) reader structure"]
impl crate::Readable for SATURATE_INTR_MASKED_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [saturate_intr_masked::W](W) writer structure"]
impl crate::Writable for SATURATE_INTR_MASKED_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets SATURATE_INTR_MASKED to value 0"]
impl crate::Resettable for SATURATE_INTR_MASKED_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
